// Ódeʎ^b`ZTW[ ver 2
//		Ver002	V`ɕύX

#include <p18f14k50.h>
#include <timers.h>
#include <delays.h>
#include <capture.h>
#include <adc.h>

#define FALSE 0
#define TRUE 1
#define BOOL char
#define	DB_MAX	10
#define NUM_RESIST_HOLD			60

#define LED				LATCbits.LATC7
#define OUTPUT_PORT		LATBbits.LATB6
#define ALT_SET			PORTBbits.RB7

#pragma config CPUDIV = NOCLKDIV
#pragma config USBDIV = OFF
#pragma config FOSC = IRC
#pragma config PLLEN = OFF
#pragma config PCLKEN = OFF
#pragma config FCMEN = OFF
#pragma config IESO = OFF
#pragma config PWRTEN = OFF
#pragma config BOREN = OFF
#pragma config BORV = 19
#pragma config WDTEN = OFF
#pragma config WDTPS = 1
#pragma config MCLRE = OFF
#pragma config HFOFST = OFF
#pragma config STVREN = OFF
#pragma config LVP = OFF
#pragma config BBSIZ = OFF
#pragma config XINST = OFF
#pragma config CP0 = OFF
#pragma config CP1 = OFF
#pragma config CPB = OFF
#pragma config CPD = OFF
#pragma config WRT0 = OFF
#pragma config WRT1 = OFF
#pragma config WRTB = OFF
#pragma config WRTC = OFF
#pragma config WRTD = OFF
#pragma config EBTR0 = OFF
#pragma config EBTR1 = OFF
#pragma config EBTRB = OFF

unsigned int resultAD[3];	
unsigned int average[3];
unsigned char button_press[3] = {0,0,0};		//o͂{^
unsigned char alt_button_press[3] = {0,0,0};	//I^lCg̃{^
unsigned char mom_button_press[3] = {0,0,0};	//[^̃{^
unsigned char debounce_count[3] = {0,0,0};	//foEXJEg

char index = 0;
unsigned char avgindex[3] = {0,0,0};

char warmup = 100;
int resist_hold = 0;	//z[hp

unsigned char button_press_result = 0;
unsigned char output_result = 0;

void main()
{
	char result;
	
	OSCCON = 0b01100010; // 8Mhz

//	^C}1̐ݒ
	OpenTimer1(TIMER_INT_ON & T1_16BIT_RW & T1_SOURCE_INT & T1_PS_1_4 & T1_OSC1EN_OFF);
	WriteTimer1(0);


//	荞݊Jn
	RCONbits.IPEN = 1;			//荞ݗDt
	IPR1bits.TMR1IP = 0;		//^C}1ʃx荞݂ɐݒ
	PIE1bits.TMR1IE = 1;		//^C}1荞݋
	INTCONbits.GIEH = 1;		//ʃx荞݂̋
	INTCONbits.GIEL = 1;		//ʃx荞݂̋

	TRISA = 0x00;	//Sďo
	TRISB = 0x80;	//RB7
	TRISC = 0x40;	//RC6

	INTCON2bits.RABPU = 0;	//vAbvg悤ɂ
	WPUBbits.WPUB7 = 1;


	ANSEL = 0x00;	//
	ANSELH = 0x01;	//AD8gp
	ADCON0 = 0b00001101; //AN3, en
	ADCON1 = 0b00000000;
	ADCON2 = 0b10100101; // 8Tad Fosc/16

	while(1)
	{
		//ADϊɓdׂ𒙂߂Ă
		TRISAbits.TRISA4 = 0;
		PORTAbits.RA4 = 1;
		ADCON0 = 0b00001111;

		//eXCb`AD̐ݒ
		switch(index)
		{
			case 0:	//AD7
				TRISCbits.TRISC6 = 0;
				PORTCbits.RC6 = 0;
				TRISCbits.TRISC6 = 1;
				ADCON0 = 0b00100001;
				break;
		}		

		//ADϊ
		ADCON0bits.GO = 1;
		while(ADCON0bits.GO);
		resultAD[index] = ReadADC();
		resultAD[index] = resultAD[index]*16;

		//dׂ𔲂
		TRISCbits.TRISC6 = 0;
		PORTCbits.RC6 = 0;

		//ŏ͒l肵Ȃ̂ŁAωsȂ
		if(warmup > 0)
		{
			warmup--;
			average[index] = resultAD[index];
		}

		//{^͂̏
		result = 0;
		if(resultAD[index] < average[index] - (average[index] >> 5))
		{	//{^ꂽƔ
			if(debounce_count[index] == DB_MAX)
			{
				button_press[index] = 1;
				result = 1;
			}
			else if(debounce_count[index] < DB_MAX)
			{
				debounce_count[index]++;
			}
		}
		else if(resultAD[index] > average[index] - (average[index] >> 7))
		{	//{^ꂽƔ
			if(debounce_count[index]  == 0)
			{
				button_press[index] = 0;
			}
			else if(debounce_count[index] > 0)
			{
				debounce_count[index]--;
			}
		}
		
		if(resultAD[index] >= average[index] - (average[index] >> 7))
		{	//ϒl̍XV
			result = 0;
		}
		
		if(result == 0)
		{	//ϒlXV̂ݍXV
			avgindex[index]++;
			if(resultAD[index] > average[index])
			{
				if(avgindex[index] >= 16)
				{
					average[index] = average[index] + (int)(resultAD[index] - average[index])/16;
					avgindex[index] = 0;
				}
			}
			else
			{
				if(avgindex[index] >= 96)
				{
					average[index] = average[index] + (int)(resultAD[index] - average[index])/16;
					avgindex[index] = 0;
				}
			}
		}

		if((mom_button_press[index] == 0) && (button_press[index] == 1))
		{//I^lCg̏BOOFF^ONl𔽓]
			alt_button_press[index] = !alt_button_press[index];
		}
		mom_button_press[index] = button_press[index];

		index++;
		if(index == 1)
			index = 0;

		button_press_result = button_press[0];

		if(ALT_SET)
			output_result = mom_button_press[0];
		else
			output_result = alt_button_press[0];

		if(warmup == 0)
		{
			if(output_result)
				LED = 0;
			else
				LED = 1;

//OUTPUT1 ^b`1̏
			if(output_result)
				OUTPUT_PORT = 1;
			else
				OUTPUT_PORT = 0;
		}
		else
		{//warmup͏o͂Ȃ
			LED = 1;
			OUTPUT_PORT = 0;
		}	
	}
}


#pragma interrupt isr_high
#pragma interruptlow isr_low

#pragma code isrcode = 0x08
void isr_direct(void)
{ _asm goto isr_high _endasm}

#pragma code lowcode = 0x18
void low_direct(void)
{ _asm goto isr_low _endasm}

#pragma code
void isr_high(void)
{
}

void isr_low(void)
{
	if(PIR1bits.TMR1IF)
	{
		PIR1bits.TMR1IF = 0;

//	z[h
		if(button_press_result)
		{
			resist_hold++;
			if(resist_hold > NUM_RESIST_HOLD)
			{
				warmup = 100;
			}
		}
		else
			resist_hold = 0;
	}	
}
